//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include <stdio.h>
#include "mainUnit.h"
#include "about.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TfrmMain *frmMain;

void AddStatus(char *fmt, ...) 
{ 
	char buffer[1024];
    va_list argptr; 
    va_start(argptr, fmt); 
    vsprintf(&buffer[0], fmt, argptr); 
    va_end(argptr); 

	frmMain->memoStatus->Lines->Text =
			   frmMain->memoStatus->Lines->Text + buffer;
	frmMain->memoStatus->Perform( WM_VSCROLL, SB_BOTTOM, 0 );
	frmMain->memoStatus->Update();
}


//---------------------------------------------------------------------------
__fastcall TfrmMain::TfrmMain(TComponent* Owner)
	: TForm(Owner)
{
	HWND_SkypeAPIWindowHandle=NULL;
	StatusBar->SimpleText = "Not connected to Skype";
}
//---------------------------------------------------------------------------
void __fastcall TfrmMain::WndProc(TMessage &Msg)
{
    // Return Code (Msg.Result) must be different from zero, otherwise
	// Skype will consider the connection broken.
	
	if(Msg.Msg == WM_SkypeControlAPIDiscover)
	{
		AddStatus("WM_SkypeControlAPIDiscover\r\n");
		Msg.Result = 1;	
	}
	else if(Msg.Msg == WM_SkypeControlAPIAttach)
	{
		Msg.Result = 1;
		AddStatus("WM_SkypeControlAPIAttach\r\n");

		switch(Msg.LParam)
		{
			case SKYPECONTROLAPI_ATTACH_SUCCESS:
				AddStatus("Connected.\r\n");
				HWND_SkypeAPIWindowHandle = (HWND)(Msg.WParam);
				StatusBar->SimpleText = "Connected to Skype";
				break;
			case SKYPECONTROLAPI_ATTACH_PENDING_AUTHORIZATION:
				AddStatus("Pending authorization...\r\n");
				StatusBar->SimpleText = "Pending authorization...";
				break;
			case SKYPECONTROLAPI_ATTACH_REFUSED:
				AddStatus("Connection refused!\r\n");
				break;
			case SKYPECONTROLAPI_ATTACH_NOT_AVAILABLE:
				AddStatus("Skype API not available!\r\n");
				break;
			case SKYPECONTROLAPI_ATTACH_API_AVAILABLE:
				AddStatus("Try connect now (API available).\r\n");
				break;
		}
	}
	else if(Msg.Msg == WM_COPYDATA)
	{
		Msg.Result = 1;
		AddStatus("WM_COPYDATA\r\n");
		if( HWND_SkypeAPIWindowHandle==(HWND)Msg.WParam )
		{
			PCOPYDATASTRUCT poCopyData=(PCOPYDATASTRUCT)Msg.LParam;
			AddStatus( "Message from Skype(%u): %.*s\r\n", poCopyData->dwData, poCopyData->cbData, poCopyData->lpData);
		}
	}
	else
		TForm::WndProc(Msg);	// don't pass any of skype messages here!
}

//---------------------------------------------------------------------------
void __fastcall TfrmMain::btnSkypeSendClick(TObject *Sender)
{
	if(!HWND_SkypeAPIWindowHandle)
	{
		SendMessage(HWND_BROADCAST, WM_SkypeControlAPIDiscover, (WPARAM)Handle, 0);
    }
	if(HWND_SkypeAPIWindowHandle && edCommand->Text.Length())
	{
		char szMsg[1024];	///< \todo zabezpieczyc
		strcpy(szMsg, edCommand->Text.c_str());

		COPYDATASTRUCT oCopyData;
		// send command to skype
		oCopyData.dwData=0;
		oCopyData.lpData = szMsg;
		oCopyData.cbData = strlen(szMsg)+1;
		if( oCopyData.cbData!=1 )
		{
			if(!SendMessage( HWND_SkypeAPIWindowHandle,
				WM_COPYDATA,
				(WPARAM)Handle,
				(LPARAM)&oCopyData))
			{
				HWND_SkypeAPIWindowHandle=NULL;
				AddStatus("Disconnected!\r\n");
				StatusBar->SimpleText = "Skype disconnected.";
			}
		}
	}
}
//---------------------------------------------------------------------------
void __fastcall TfrmMain::FormCreate(TObject *Sender)
{
	WM_SkypeControlAPIDiscover = RegisterWindowMessage("SkypeControlAPIDiscover");
	WM_SkypeControlAPIAttach = RegisterWindowMessage("SkypeControlAPIAttach");
	SendMessage(HWND_BROADCAST, WM_SkypeControlAPIDiscover, (WPARAM)Handle, 0);
}
//---------------------------------------------------------------------------

void __fastcall TfrmMain::About1Click(TObject *Sender)
{
	AboutBox->ShowModal();	
}
//---------------------------------------------------------------------------

